package com.whatever.xsp.ext.cmds;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import lotus.domino.NotesException;
import org.eclipse.jface.action.IStatusLineManager;
import com.ibm.notes.java.api.data.NotesDatabaseData;
import com.ibm.notes.java.ui.NotesUIWorkspace;
import com.ibm.xsp.rcp.IExtendedCommands;
import com.ibm.xsp.rcp.IRcpContext;
import com.ibm.xsp.rcp.XspViewPart;

public class CommandHandler implements IExtendedCommands {
	public static final String UpdateStatusBar  = "com.whatever.xsp.ext.cmds.UpdateNotesStatusBar";
	public static final String AddDbToWorkspace = "com.whatever.xsp.ext.cmds.AddDbToWorkspace";
	// execute the commands we support
	public Object executeCommand(IRcpContext rcpContext, String command, List<?> params) {
		if (command.equalsIgnoreCase(UpdateStatusBar)) {
			updateNotesStatusBar(rcpContext,params);
		} else if (command.equalsIgnoreCase(AddDbToWorkspace)) {
			addDbToWorkspace(rcpContext,params);
		}
		return null;
	}
	// list the commands we support
	public List<String> getCommandList() {
		ArrayList<String> cmdList = new ArrayList<String>();
		cmdList.add(UpdateStatusBar);
		cmdList.add(AddDbToWorkspace);
		return cmdList;
	}
	// UpdateStatusBar Command (Print a message on the Notes status bar)
	private Object updateNotesStatusBar(IRcpContext context, List<?> params) {
		XspViewPart xvp = (XspViewPart)context.getViewPart();
		IStatusLineManager statusManager = xvp.getViewSite().getActionBars().getStatusLineManager();
		Object arg1 = params.get(0);
		if (arg1 instanceof HashMap) {
            HashMap map = (HashMap)arg1;	
            String txt = (String)map.get("message");
            if(statusManager != null){
                statusManager.setErrorMessage(txt);
            }
        }
		return null;
	}
	// AddDbToWorkspace Command (Add a database to the Notes workspace)
	private Object addDbToWorkspace(IRcpContext context, List<?> params) {
		NotesUIWorkspace ws=new NotesUIWorkspace(); 
		try {
			Object arg1 = params.get(0);
			if (arg1 instanceof HashMap) {
				HashMap map = (HashMap)arg1;
				String server = (String)map.get("server");
				String database = (String)map.get("db");  
				if (server != null && database != null) {
					NotesDatabaseData dbData = new NotesDatabaseData(server, database);
					ws.addDatabase(dbData);
				}
			}
		} catch (NotesException e) {
			e.printStackTrace();
		}
		return null;
	}
	// etc.
}
